/*
 * GUIGaugePage.java
 *
 * Created on November 12, 2001, 1:39 PM
 */

package edu.cmu.cs.able.examples.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
/**
 *
 * @author  schmerl
 */
public class GUIGaugePage extends javax.swing.JPanel {

    StringPairVector configParams = new StringPairVector();
    StringPairVector valuesSPV = new StringPairVector ();
    javax.swing.table.DefaultTableModel valueModel = null;
    javax.swing.table.DefaultTableModel configModel = null;
    
    public GaugeControl gauge;
    public GaugeMgr gaugeMgr;
    
    private boolean preexistantGauge = false;
    
    /** Creates new form GUIGaugePage */
    public GUIGaugePage(GaugeControl gauge, GaugeMgr gaugeMgr) {
       
        if (gaugeMgr == null) {
            System.out.println ("Querying gauge");
            gauge.queryState (new StringPairVector (), configParams, valuesSPV);
            preexistantGauge = true;
        }
        else {
            gaugeMgr.queryMetaInfo(gauge.getGaugeID().gaugeType, configParams, valuesSPV);
        }
        this.gauge = gauge;
        initComponents();

        this.gaugeMgr = gaugeMgr;
        if (gaugeMgr == null) {
            bnConfigure.setEnabled (false);
            bnDelete.setEnabled (false);
        }
        
 
    }
    
    public void reportValue (String name, String value) {
        // find the name in the table
        int nameRow = 0;
        while (nameRow < valuesSPV.size () && !valuesSPV.nameAt (nameRow).equals (name)) {
            nameRow++;
        }
        
        if (nameRow != valuesSPV.size ()) {
            valueModel.setValueAt (value, nameRow, 1);
            javax.swing.event.TableModelEvent evt = new javax.swing.event.TableModelEvent (valueModel, nameRow, nameRow, 1);
            tblValues.tableChanged (evt);
        }

        // set the value in the table
        this.repaint ();
    }
    
    public void reconfigure (StringPairVector newConfigs) {
        if (newConfigs.size () == configParams.size ()) {
            configParams = newConfigs;
            for (int configI = 0; configI < configParams.size (); configI++) {
                configModel.setValueAt (configParams.nameAt (configI), configI, 0);
                configModel.setValueAt (configParams.valueAt (configI), configI, 1);
            }
        
            javax.swing.event.TableModelEvent evt = new javax.swing.event.TableModelEvent (configModel, 0, configParams.size ());
            tblConfig.tableChanged (evt);
        
            this.repaint ();
        }
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        cbIDElements = new javax.swing.JComboBox();
        tfIDElement = new javax.swing.JTextField();
        tfIDElement.setText(gauge.getGaugeID().gaugeName);
        jPanel4 = new javax.swing.JPanel();
        tblValues = new javax.swing.JTable();
        jPanel5 = new javax.swing.JPanel();
        bnConfigure = new javax.swing.JButton();
        bnDelete = new javax.swing.JButton();
        tblConfig = new javax.swing.JTable();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        jPanel1.setBorder(new javax.swing.border.TitledBorder("Gauge ID"));
        cbIDElements.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Gauge Name:", "Gauge Type:", "Model Name:", "Model Type:" }));
        cbIDElements.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cbIDElementsItemStateChanged(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        jPanel1.add(cbIDElements, gridBagConstraints2);
        
        tfIDElement.setEditable(false);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.weightx = 1.0;
        jPanel1.add(tfIDElement, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 360;
        add(jPanel1, gridBagConstraints1);
        
        jPanel4.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        jPanel4.setBorder(new javax.swing.border.TitledBorder("Gauge Reporting"));
        int numValuesReported = valuesSPV.size();
        Object [][] valueVector = new Object [numValuesReported][2];
        for (int valueI = 0; valueI < numValuesReported; valueI++) {
            valueVector [valueI][0] = valuesSPV.nameAt(valueI);
            if (preexistantGauge) {
                valueVector [valueI][1] = valuesSPV.valueAt(valueI);
            }
        }
        valueModel = new javax.swing.table.DefaultTableModel(valueVector, new String [] {"Name", "Value"}) {public boolean isCellEditable(int rowIndex, int columnIndex) {return false;}};
        tblValues.setModel(valueModel);
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 0;
        gridBagConstraints3.gridwidth = 2;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.weighty = 1.0;
        jPanel4.add(tblValues, gridBagConstraints3);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel4, gridBagConstraints1);
        
        jPanel5.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        
        jPanel5.setBorder(new javax.swing.border.TitledBorder("Gauge Configuration"));
        bnConfigure.setText("Configure");
        bnConfigure.setActionCommand("configure");
        bnConfigure.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                configureGauge(evt);
            }
        });
        
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 0;
        gridBagConstraints4.gridy = 1;
        gridBagConstraints4.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints4.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints4.weightx = 1.0;
        jPanel5.add(bnConfigure, gridBagConstraints4);
        
        bnDelete.setText("Delete");
        bnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteGauge(evt);
            }
        });
        
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 1;
        gridBagConstraints4.gridy = 1;
        gridBagConstraints4.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints4.weightx = 1.0;
        jPanel5.add(bnDelete, gridBagConstraints4);
        
        int numConfigs = configParams.size();
        Object [][] configVector = new Object [numConfigs][2];
        for (int configI = 0; configI < numConfigs; configI++) {
            configVector [configI][0] = configParams.nameAt(configI);
            if (preexistantGauge) {
                configVector [configI][1] = configParams.valueAt(configI);
            }
        }
        configModel = new javax.swing.table.DefaultTableModel(configVector, new String [] {"Name", "Value"}) {public boolean isCellEditable(int row, int col) {return col == 1;}};
        tblConfig.setModel(configModel);
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 0;
        gridBagConstraints4.gridy = 0;
        gridBagConstraints4.gridwidth = 2;
        gridBagConstraints4.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints4.weightx = 1.0;
        gridBagConstraints4.weighty = 1.0;
        jPanel5.add(tblConfig, gridBagConstraints4);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel5, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void cbIDElementsItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cbIDElementsItemStateChanged
        if (evt.getSource () == cbIDElements) {
            String idElement = cbIDElements.getSelectedItem ().toString ();
            if (idElement.equals ("Gauge Name:")) {
                tfIDElement.setText (gauge.getGaugeID ().gaugeName);
            }
            else if (idElement.equals ("Gauge Type:")) {
                tfIDElement.setText (gauge.getGaugeID ().gaugeName);
            }
            else if (idElement.equals ("Model Name:")) {
                tfIDElement.setText (gauge.getGaugeID ().modelName);
            }
            else if (idElement.equals ("Model Type:")) {
                tfIDElement.setText (gauge.getGaugeID ().modelType);
            }
        }
    }//GEN-LAST:event_cbIDElementsItemStateChanged

    private void deleteGauge(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteGauge
        // Add your handling code here:
        gaugeMgr.deleteGauge (gauge);
    }//GEN-LAST:event_deleteGauge

    private void configureGauge(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_configureGauge
        // Add your handling code here:
        tblConfig.clearSelection ();
        StringPairVector newConfigs = new StringPairVector ();
        for (int i = 0; i < configParams.size (); i++) {
            String name = (String )tblConfig.getValueAt (i, 0);
            String value = (String )tblConfig.getValueAt (i, 1);
            if (name != null && value != null) {
                newConfigs.addElement (name,value);
            }
        }
        
        if (gauge.configure (newConfigs)) {
            configParams = newConfigs;
        }
    }//GEN-LAST:event_configureGauge


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JComboBox cbIDElements;
    private javax.swing.JTextField tfIDElement;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JTable tblValues;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JButton bnConfigure;
    private javax.swing.JButton bnDelete;
    private javax.swing.JTable tblConfig;
    // End of variables declaration//GEN-END:variables

}
