/*
 * JDialog.java
 *
 * Created on November 8, 2001, 4:53 PM
 */

package edu.cmu.cs.able.examples.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.*;
import edu.cmu.cs.able.gauges.Siena.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
/**
 *
 * @author  schmerl
 */
public class GUITimeGaugeMgr extends javax.swing.JDialog implements Runnable, edu.cmu.cs.able.gaugeInfrastructure.GaugeMgr {
    
    SienaTimeGaugeMgr timeGaugeMgr;
    private Hashtable p2out = new Hashtable();
    private Hashtable out2p = new Hashtable();
    private Hashtable threadState = new Hashtable();
    private Hashtable p2text = new Hashtable();
    private Hashtable gauge2Process = new Hashtable();
    public String getGaugeMgrID() {return timeGaugeMgr.getGaugeMgrID();}
    
    public String senp = null;
    private static boolean debug = false;
    
    /** Creates new form JDialog */
    public GUITimeGaugeMgr(java.awt.Frame parent, boolean modal, String senp) {
        super(parent, modal);
        initComponents();
        timeGaugeMgr = new SienaTimeGaugeMgr(senp, false);
        ((SienaGaugeReportingBus )SienaGaugeReportingBus.getReportingBus()).sienaBus.registerGaugeMgr(this);
        this.senp = senp;
    }
    
    public GaugeControl createGauge(GaugeID gauge, StringPairVector setupParams, StringPairVector mappings) {
        
        if (managesType(gauge.gaugeType)) {
            SienaGaugeMgrGaugeHandle gaugeHandle = new SienaGaugeMgrGaugeHandle(gauge);
            String args = " -mn " + gauge.modelName + " -mt " + gauge.modelType +
            " -gt " + gauge.gaugeType + " -gn " + gauge.gaugeName +
            " -creator \"" + getGaugeMgrID() + "\" -senp " + senp;
            if (debug) {
                args += " -debug";
            }
            try {
                jTextPane1.append("Creating " + gauge.gaugeType + args);
                int pos = jTextPane1.getText().length();
                jTextPane1.setCaretPosition(pos);
        
                jTextPane1.repaint();
                Process gaugeProcess = Runtime.getRuntime().exec("java " + gauge.gaugeType + args);
                Thread gaugeInOutput = new Thread(this, "IN" + gauge.toString());
                Thread gaugeErrOutput = new Thread(this, "ER" + gauge.toString());
                
                javax.swing.JTextArea outputTextPane = new javax.swing.JTextArea();
                outputTextPane.setLineWrap (true);
                javax.swing.JScrollPane sp = new javax.swing.JScrollPane(outputTextPane);
                sp.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                sp.setPreferredSize(new Dimension(450, 300));
                this.jTabbedPane1.addTab(gauge.gaugeName, sp);
                p2text.put(gaugeProcess, outputTextPane);
                p2out.put(gaugeProcess.toString() + "IN", gaugeInOutput);
                p2out.put(gaugeProcess.toString() + "ERR", gaugeErrOutput);
                out2p.put(gaugeInOutput, gaugeProcess);
                out2p.put(gaugeErrOutput, gaugeProcess);
                gauge2Process.put(gauge.gaugeName, gaugeProcess);
                gaugeInOutput.start();
                gaugeErrOutput.start();
                return new SienaGaugeMgrGaugeHandle(gauge);
            }
            catch (IOException ex) {
                System.err.println("Could not create gauge");
                ex.printStackTrace();
                return null;
            }
        }
        return null;
    }
    
    public boolean deleteGauge(GaugeControl gauge) {
        System.out.println("In delete gauge " + gauge.getGaugeID().gaugeName);
        Process gaugeProcess = (Process )gauge2Process.get(gauge.getGaugeID().gaugeName);
        if (gaugeProcess != null) {
            Thread output1Thread = (Thread )p2out.get(gaugeProcess.toString() + "IN");
            Thread output2Thread = (Thread )p2out.get(gaugeProcess.toString() + "ERR");
            // This may not make a gauge announce a delete event -- put it in the finalize of the gauge?
            threadState.put(output1Thread, "stop");
            threadState.put(output2Thread, "stop");
            try {
                gaugeProcess.destroy();
                jTabbedPane1.removeTabAt(jTabbedPane1.indexOfTab(gauge.getGaugeID().gaugeName));
            }
            catch (Throwable t) {
                System.err.println("Could not destroy gauge");
                t.printStackTrace();
                return false;
            }
        }
        return true;
    }
    
    public boolean managesType(String gaugeType) {
        return gaugeType.equals("edu.cmu.cs.able.gauges.Siena.SienaTimeGauge");
    }
    
    public boolean queryMetaInfo(String gaugeType, StringPairVector configParamsMeta, StringPairVector valuesMeta) {
        if (managesType(gaugeType)) {
            configParamsMeta.addElement("frequency", "int");
            configParamsMeta.addElement("report", "boolean");
            valuesMeta.addElement("date", "String");
            return true;
        }
        else {
            return false;
        }
    }
    
    public void run() {
        
        Thread myThread = Thread.currentThread();
        Process gaugeProcess = (Process )out2p.get(myThread);
        javax.swing.JTextArea output = (javax.swing.JTextArea )p2text.get(gaugeProcess);
        if (gaugeProcess != null) {
            BufferedReader in = null;
            if (myThread.getName().substring(0,2).equals("IN")) {
                in = new BufferedReader(new InputStreamReader(gaugeProcess.getInputStream()));
            }
            else {
                in = new BufferedReader(new InputStreamReader(gaugeProcess.getErrorStream()));
            }
            
            while (threadState.get(myThread) == null) {
                try {
                    String n = in.readLine();
                    if (n != null) {
                        
                        while (n != null) {
                            
                            output.append("\n" + n);
                            int pos = output.getText().length();
                            output.setCaretPosition(pos);
                            output.repaint();
                            n = in.readLine();
                        }
                    }
                }
                catch (IOException e) {
                    e.printStackTrace();
                }
                catch (Exception e) {}
                try {
                    Thread.sleep(1000);
                }
                catch (Exception e) {
                    e.printStackTrace();
                }
            }
            
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextArea();
        bnQuit = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        
        getContentPane().setLayout(new java.awt.GridLayout(2, 0));
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText("Time Gauge Manager");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(jLabel1, gridBagConstraints1);
        
        jScrollPane2.setViewportBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(500, 250));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(500, 250));
        jTextPane1.setLineWrap(true);
        jScrollPane2.setViewportView(jTextPane1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        jPanel1.add(jScrollPane2, gridBagConstraints1);
        
        bnQuit.setText("Quit");
        bnQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnQuitActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel1.add(bnQuit, gridBagConstraints1);
        
        getContentPane().add(jPanel1);
        
        getContentPane().add(jTabbedPane1);
        
        pack();
    }//GEN-END:initComponents

    private void bnQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnQuitActionPerformed
        // Add your handling code here:
        // Should really delete all gauges being managed by me
        System.exit (0);
    }//GEN-LAST:event_bnQuitActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        String senp = "localhost:1111";
        for (int i = 0; i < args.length; i++) {
            
            if (args [i].equals("-senp")) {
                senp = args [++i];
                edu.cmu.cs.able.gaugeInfrastructure.Siena.Initialization.initSiena(senp);
            }
            else if (args [i].equals("-debug")) {
                edu.cmu.cs.able.gaugeInfrastructure.util.Global.debugFlag = true;
                debug = true;
            }
        }
        
        Global.initLookAndFeel("Metal");
        
        new GUITimeGaugeMgr(new javax.swing.JFrame(), true, senp).show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextPane1;
    private javax.swing.JButton bnQuit;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
    
}
