/*
 * GaugeCreationDialog.java
 *
 * Created on November 12, 2001, 11:36 AM
 */

package edu.cmu.cs.able.examples.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
/**
 *
 * @author  schmerl
 */
public class GaugeCreationDialog extends javax.swing.JDialog {

    GUIGaugeConsumer consumer = null;
    
    /** Creates new form GaugeCreationDialog */
    public GaugeCreationDialog(java.awt.Frame parent, GaugeID gauge, boolean modal, GUIGaugeConsumer gc) {
        super(parent, modal);
        initComponents();
        consumer = gc;
        lbGauge.setText (gauge.gaugeName);
        bnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeDialog(null);
            }
        });
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        bnOK = new javax.swing.JButton();
        bnCancel = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        lbGauge = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblSetup = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        tblMappings = new javax.swing.JTable();
        
        setName("createDialog");
        setModal(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        bnOK.setText("OK");
        bnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnOKActionPerformed(evt);
            }
        });
        
        jPanel1.add(bnOK);
        
        bnCancel.setText("Cancel");
        bnCancel.setActionCommand("Cancel");
        bnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnCancelActionPerformed(evt);
            }
        });
        
        jPanel1.add(bnCancel);
        
        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);
        
        jLabel1.setText("Creation parameters for: ");
        jPanel2.add(jLabel1);
        
        lbGauge.setText("A gauge");
        jPanel2.add(lbGauge);
        
        getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);
        
        jPanel4.setLayout(new java.awt.GridLayout(1, 0));
        
        tblSetup.setModel(new javax.swing.table.DefaultTableModel(
        new Object [][] {
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null}
        },
        new String [] {
            "Name", "Value"
        }
        ));
        tblSetup.setCellSelectionEnabled(true);
        jScrollPane1.setViewportView(tblSetup);
        
        jTabbedPane1.addTab("Setup", jScrollPane1);
        
        tblMappings.setModel(new javax.swing.table.DefaultTableModel(
        new Object [][] {
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null},
            {null, null}
        },
        new String [] {
            "Value", "Property"
        }
        ));
        jScrollPane2.setViewportView(tblMappings);
        
        jTabbedPane1.addTab("Mappings", jScrollPane2);
        
        jPanel4.add(jTabbedPane1);
        
        getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);
        
        pack();
    }//GEN-END:initComponents

    private void bnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnCancelActionPerformed
        // Add your handling code here:
        closeDialog (null);
    }//GEN-LAST:event_bnCancelActionPerformed

    private void bnOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnOKActionPerformed
        if (consumer != null) {
            consumer.doCreateNewGauge (this);
        }
        setVisible (false);
    }//GEN-LAST:event_bnOKActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new GaugeCreationDialog(new javax.swing.JFrame(), new GaugeID (), true, null).show();
    }

    public StringPairVector getSetupParams () {
        tblSetup.clearSelection ();
        StringPairVector setup = new StringPairVector ();
        int row = 0;
        while (row < tblSetup.getRowCount () && tblSetup.getValueAt (row, 0) != null) {
            if (tblSetup.getValueAt (row, 1) != null) {
                setup.addElement ((String )tblSetup.getValueAt (row, 0),
                                  (String )tblSetup.getValueAt (row, 1));
            }
            row++;
        }
        return setup;
    }
    
    public StringPairVector getMappings () {
        tblMappings.clearSelection ();
        StringPairVector mappings = new StringPairVector ();
        int row = 0;
        while (row < tblMappings.getRowCount () && tblMappings.getValueAt (row, 0) != null) {
            if (tblMappings.getValueAt (row, 1) != null) {
                mappings.addElement ((String )tblMappings.getValueAt (row, 0),
                                     (String )tblMappings.getValueAt (row, 1));
            }
            row++;
        }
        return mappings;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton bnOK;
    private javax.swing.JButton bnCancel;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lbGauge;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tblSetup;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable tblMappings;
    // End of variables declaration//GEN-END:variables

}
