/*
 * TimeGaugeConsumer.java
 *
 * Created on November 7, 2001, 12:41 PM
 */

package edu.cmu.cs.able.examples.Siena;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.Siena.*;
import edu.cmu.cs.able.gauges.Siena.*;
import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
/**
 *
 * @author  schmerl
 * @version 
 */
public class TimeGaugeConsumer extends edu.cmu.cs.able.gaugeInfrastructure.Siena.SienaGaugeConsumer {

    GaugeMgr gaugeMgr = null;
    
    /** Creates new TimeGaugeConsumer */
    public TimeGaugeConsumer() {
        super ();
    }

    public void createAndListenToGauge(String gaugeName) {
        if (gaugeMgr == null) {
            gaugeMgr = new SienaGaugeMgrHandle ("edu.cmu.cs.able.gauges.Siena.SienaTimeGauge");
            if (gaugeMgr.getGaugeMgrID () == null) {
                System.err.println ("Could not find Gauge Manager");
                System.exit (0);
            }
        }
        
        StringPairVector setupParams = new StringPairVector ();
        StringPairVector mappings = new StringPairVector ();
        setupParams.addElement ("frequency", "1000");
        mappings.addElement ("date", "l.date");
        GaugeID requestedID = new GaugeID ();
        requestedID.modelType = "Acme";
        requestedID.modelName = "simple.acme";
        requestedID.gaugeName = gaugeName;
        requestedID.gaugeType = "edu.cmu.cs.able.gauges.Siena.SienaTimeGauge";
        
        GaugeControl timeGauge = gaugeMgr.createGauge (requestedID, setupParams, mappings);
        if (timeGauge == null) {
            System.err.println ("Could not create gauge.");
            return;
        }
        else {
            System.out.println ("Created gauge " + timeGauge.getGaugeID ().toString ());
        }
        ((SienaGaugeHandle )timeGauge).registerGaugeConsumer (this);
        
        StringPairVector config = new StringPairVector ();
        config.addElement ("report", "true");
        boolean configured = timeGauge.configure (config);
        if (configured) {
            System.out.println ("Gauge successfully configured");
        }
        try {
            Thread.sleep (5000);
        }
        catch (Exception e) {}
        
        config.removeAllElements ();
        config.addElement ("report", "false");
        configured = timeGauge.configure (config);
        String value = timeGauge.queryValue ("date");
        if (value != null) {
            System.out.println ("Query value: " + value);
        } else {
            System.out.println ("Query value ERROR");
        }
        
        if (!timeGauge.queryAllValues (new GaugeValueVector ())) {
            System.out.println ("Could not query all values.");
        }
        
        gaugeMgr.deleteGauge (timeGauge);
        
    }
    
    public void onReportValue (GaugeControl gauge, String valueName, String propertyName, String value) {
        System.out.println (gauge.getGaugeID ().gaugeName + " REPORT: " + valueName + " " + value);
    }
    
    public static void main(String[] args) {
        String gaugeName = "G";
        int numberOfGauges = 1;
        for (int i = 0; i < args.length; i++) {
           
            if (args [i].equals ("-senp")) {
                edu.cmu.cs.able.gaugeInfrastructure.Siena.Initialization.initSiena (args [++i]);
            }
            else if (args [i].equals ("-debug")) {
                edu.cmu.cs.able.gaugeInfrastructure.util.Global.debugFlag = true;
            }
            else if (args [i].equals ("-gn")) {
                gaugeName = args [++i];
            }
            else if (args [i].equals ("-num")) {
                numberOfGauges = Integer.parseInt (args [++i]);
            }
            else {
                printUsageMessage ();
            }
        }
        TimeGaugeConsumer gc = new TimeGaugeConsumer ();
        
        for (int j = 0; j < numberOfGauges; j++) {
            gc.createAndListenToGauge (gaugeName + j);
        }
    }
    
    public static void printUsageMessage () {
        System.err.println ("Usage: TimeGaugeConsumer -senp <siena-port>");
        
    }
    
}
